---
title: Create RUM replay session watch
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > Rum Replay Viewership
---

# Create RUM replay session watch{% #create-rum-replay-session-watch %}
Copy pageCopied
{% tab title="v2" %}

| Datadog site      | API endpoint                                                                       |
| ----------------- | ---------------------------------------------------------------------------------- |
| ap1.datadoghq.com | POST https://api.ap1.datadoghq.com/api/v2/rum/replay/sessions/{session_id}/watches |
| ap2.datadoghq.com | POST https://api.ap2.datadoghq.com/api/v2/rum/replay/sessions/{session_id}/watches |
| app.datadoghq.eu  | POST https://api.datadoghq.eu/api/v2/rum/replay/sessions/{session_id}/watches      |
| app.ddog-gov.com  | POST https://api.ddog-gov.com/api/v2/rum/replay/sessions/{session_id}/watches      |
| us2.ddog-gov.com  | POST https://api.us2.ddog-gov.com/api/v2/rum/replay/sessions/{session_id}/watches  |
| app.datadoghq.com | POST https://api.datadoghq.com/api/v2/rum/replay/sessions/{session_id}/watches     |
| us3.datadoghq.com | POST https://api.us3.datadoghq.com/api/v2/rum/replay/sessions/{session_id}/watches |
| us5.datadoghq.com | POST https://api.us5.datadoghq.com/api/v2/rum/replay/sessions/{session_id}/watches |

### Overview

Record a session watch.

### Arguments

#### Path Parameters

| Name                         | Type   | Description                       |
| ---------------------------- | ------ | --------------------------------- |
| session_id [*required*] | string | Unique identifier of the session. |

### Request

#### Body Data (required)



{% tab title="Model" %}

| Parent field | Field                            | Type      | Description                                                                                                |
| ------------ | -------------------------------- | --------- | ---------------------------------------------------------------------------------------------------------- |
|              | data [*required*]           | object    | Data object representing a session watch record, including its identifier, type, and attributes.           |
| data         | attributes                       | object    | Attributes for recording a session watch event, including the application, event reference, and timestamp. |
| attributes   | application_id [*required*] | string    | Unique identifier of the RUM application containing the session.                                           |
| attributes   | data_source                      | string    | Data source type indicating the origin of the session data (e.g., rum or product_analytics).               |
| attributes   | event_id [*required*]       | string    | Unique identifier of the RUM event that was watched.                                                       |
| attributes   | timestamp [*required*]      | date-time | Timestamp when the session was watched.                                                                    |
| data         | id                               | string    | Unique identifier of the watch record.                                                                     |
| data         | type [*required*]           | enum      | Rum replay watch resource type. Allowed enum values: `rum_replay_watch`                                    |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "application_id": "aaaaaaaa-1111-2222-3333-bbbbbbbbbbbb",
      "data_source": "string",
      "event_id": "11111111-2222-3333-4444-555555555555",
      "timestamp": "2026-01-13T17:15:53.208340Z"
    },
    "id": "string",
    "type": "rum_replay_watch"
  }
}
```

{% /tab %}

### Response

{% tab title="201" %}
Created
{% tab title="Model" %}
A single RUM replay session watch resource returned by create operations.

| Parent field | Field                            | Type      | Description                                                                                                |
| ------------ | -------------------------------- | --------- | ---------------------------------------------------------------------------------------------------------- |
|              | data [*required*]           | object    | Data object representing a session watch record, including its identifier, type, and attributes.           |
| data         | attributes                       | object    | Attributes for recording a session watch event, including the application, event reference, and timestamp. |
| attributes   | application_id [*required*] | string    | Unique identifier of the RUM application containing the session.                                           |
| attributes   | data_source                      | string    | Data source type indicating the origin of the session data (e.g., rum or product_analytics).               |
| attributes   | event_id [*required*]       | string    | Unique identifier of the RUM event that was watched.                                                       |
| attributes   | timestamp [*required*]      | date-time | Timestamp when the session was watched.                                                                    |
| data         | id                               | string    | Unique identifier of the watch record.                                                                     |
| data         | type [*required*]           | enum      | Rum replay watch resource type. Allowed enum values: `rum_replay_watch`                                    |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "application_id": "aaaaaaaa-1111-2222-3333-bbbbbbbbbbbb",
      "data_source": "string",
      "event_id": "11111111-2222-3333-4444-555555555555",
      "timestamp": "2026-01-13T17:15:53.208340Z"
    },
    "id": "string",
    "type": "rum_replay_watch"
  }
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                  \## default
# 
 \# Path parameters export session_id="00000000-0000-0000-0000-000000000001" \# Curl command curl -X POST "https://api.datadoghq.com/api/v2/rum/replay/sessions/${session_id}/watches" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \
-d @- << EOF
{
  "data": {
    "attributes": {
      "application_id": "aaaaaaaa-1111-2222-3333-bbbbbbbbbbbb",
      "event_id": "11111111-2222-3333-4444-555555555555",
      "timestamp": "2026-01-13T17:15:53.208340Z"
    },
    "type": "rum_replay_watch"
  }
}
EOF 
                
##### 

```python
"""
Create rum replay session watch returns "Created" response
"""

from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.rum_replay_viewership_api import RumReplayViewershipApi
from datadog_api_client.v2.model.watch import Watch
from datadog_api_client.v2.model.watch_data import WatchData
from datadog_api_client.v2.model.watch_data_attributes import WatchDataAttributes
from datadog_api_client.v2.model.watch_data_type import WatchDataType
from datetime import datetime
from dateutil.tz import tzutc

body = Watch(
    data=WatchData(
        attributes=WatchDataAttributes(
            application_id="aaaaaaaa-1111-2222-3333-bbbbbbbbbbbb",
            event_id="11111111-2222-3333-4444-555555555555",
            timestamp=datetime(2026, 1, 13, 17, 15, 53, 208340, tzinfo=tzutc()),
        ),
        type=WatchDataType.RUM_REPLAY_WATCH,
    ),
)

configuration = Configuration()
with ApiClient(configuration) as api_client:
    api_instance = RumReplayViewershipApi(api_client)
    response = api_instance.create_rum_replay_session_watch(
        session_id="00000000-0000-0000-0000-000000000001", body=body
    )

    print(response)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" python3 "example.py"
##### 

```ruby
# Create rum replay session watch returns "Created" response

require "datadog_api_client"
api_instance = DatadogAPIClient::V2::RumReplayViewershipAPI.new

body = DatadogAPIClient::V2::Watch.new({
  data: DatadogAPIClient::V2::WatchData.new({
    attributes: DatadogAPIClient::V2::WatchDataAttributes.new({
      application_id: "aaaaaaaa-1111-2222-3333-bbbbbbbbbbbb",
      event_id: "11111111-2222-3333-4444-555555555555",
      timestamp: "2026-01-13T17:15:53.208340Z",
    }),
    type: DatadogAPIClient::V2::WatchDataType::RUM_REPLAY_WATCH,
  }),
})
p api_instance.create_rum_replay_session_watch("00000000-0000-0000-0000-000000000001", body)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" rb "example.rb"
##### 

```go
// Create rum replay session watch returns "Created" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"
	"time"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	body := datadogV2.Watch{
		Data: datadogV2.WatchData{
			Attributes: &datadogV2.WatchDataAttributes{
				ApplicationId: "aaaaaaaa-1111-2222-3333-bbbbbbbbbbbb",
				EventId:       "11111111-2222-3333-4444-555555555555",
				Timestamp:     time.Date(2026, 1, 13, 17, 15, 53, 208340, time.UTC),
			},
			Type: datadogV2.WATCHDATATYPE_RUM_REPLAY_WATCH,
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewRumReplayViewershipApi(apiClient)
	resp, r, err := api.CreateRumReplaySessionWatch(ctx, "00000000-0000-0000-0000-000000000001", body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `RumReplayViewershipApi.CreateRumReplaySessionWatch`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `RumReplayViewershipApi.CreateRumReplaySessionWatch`:\n%s\n", responseContent)
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" go run "main.go"
##### 

```java
// Create rum replay session watch returns "Created" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.RumReplayViewershipApi;
import com.datadog.api.client.v2.model.Watch;
import com.datadog.api.client.v2.model.WatchData;
import com.datadog.api.client.v2.model.WatchDataAttributes;
import com.datadog.api.client.v2.model.WatchDataType;
import java.time.OffsetDateTime;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    RumReplayViewershipApi apiInstance = new RumReplayViewershipApi(defaultClient);

    Watch body =
        new Watch()
            .data(
                new WatchData()
                    .attributes(
                        new WatchDataAttributes()
                            .applicationId("aaaaaaaa-1111-2222-3333-bbbbbbbbbbbb")
                            .eventId("11111111-2222-3333-4444-555555555555")
                            .timestamp(OffsetDateTime.parse("2026-01-13T17:15:53.208340Z")))
                    .type(WatchDataType.RUM_REPLAY_WATCH));

    try {
      Watch result =
          apiInstance.createRumReplaySessionWatch("00000000-0000-0000-0000-000000000001", body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println(
          "Exception when calling RumReplayViewershipApi#createRumReplaySessionWatch");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" java "Example.java"
##### 

```rust
// Create rum replay session watch returns "Created" response
use chrono::{DateTime, Utc};
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_rum_replay_viewership::RumReplayViewershipAPI;
use datadog_api_client::datadogV2::model::Watch;
use datadog_api_client::datadogV2::model::WatchData;
use datadog_api_client::datadogV2::model::WatchDataAttributes;
use datadog_api_client::datadogV2::model::WatchDataType;

#[tokio::main]
async fn main() {
    let body = Watch::new(
        WatchData::new(WatchDataType::RUM_REPLAY_WATCH).attributes(WatchDataAttributes::new(
            "aaaaaaaa-1111-2222-3333-bbbbbbbbbbbb".to_string(),
            "11111111-2222-3333-4444-555555555555".to_string(),
            DateTime::parse_from_rfc3339("2026-01-13T17:15:53.208340+00:00")
                .expect("Failed to parse datetime")
                .with_timezone(&Utc),
        )),
    );
    let configuration = datadog::Configuration::new();
    let api = RumReplayViewershipAPI::with_config(configuration);
    let resp = api
        .create_rum_replay_session_watch("00000000-0000-0000-0000-000000000001".to_string(), body)
        .await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" cargo run
##### 

```typescript
/**
 * Create rum replay session watch returns "Created" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
const apiInstance = new v2.RumReplayViewershipApi(configuration);

const params: v2.RumReplayViewershipApiCreateRumReplaySessionWatchRequest = {
  body: {
    data: {
      attributes: {
        applicationId: "aaaaaaaa-1111-2222-3333-bbbbbbbbbbbb",
        eventId: "11111111-2222-3333-4444-555555555555",
        timestamp: new Date(2026, 1, 13, 17, 15, 53, 208340),
      },
      type: "rum_replay_watch",
    },
  },
  sessionId: "00000000-0000-0000-0000-000000000001",
};

apiInstance
  .createRumReplaySessionWatch(params)
  .then((data: v2.Watch) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" tsc "example.ts"
{% /tab %}
